v22bis_tx.c File Reference
`#include <stdio.h>`
`#include <inttypes.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "floating_fudge.h"`
`#include "spandsp/telephony.h"`
`#include "spandsp/fast_convert.h"`
`#include "spandsp/logging.h"`
`#include "spandsp/complex.h"`
`#include "spandsp/vector_float.h"`
`#include "spandsp/complex_vector_float.h"`
`#include "spandsp/vector_int.h"`
`#include "spandsp/complex_vector_int.h"`
`#include "spandsp/async.h"`
`#include "spandsp/dds.h"`
`#include "spandsp/power_meter.h"`
`#include "spandsp/v29rx.h"`
`#include "spandsp/v22bis.h"`
`#include "spandsp/private/logging.h"`
`#include "spandsp/private/v22bis.h"`
`#include "v22bis_tx_floating_rrc.h"`

## Macros

#define | ms_to_symbols(t)

## Functions

int | v22bis_tx (v22bis_state_t *s, int16_t amp[], int len)
void | v22bis_tx_power (v22bis_state_t *s, float power)
| Adjust a V.22bis modem transmit context's output power.
void | v22bis_set_get_bit (v22bis_state_t *s, get_bit_func_t get_bit, void *user_data)
| Change the get_bit function associated with a V.22bis modem context.
void | v22bis_set_put_bit (v22bis_state_t *s, put_bit_func_t put_bit, void *user_data)
| Change the put_bit function associated with a V.22bis modem context.
void | v22bis_set_modem_status_handler (v22bis_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.22bis modem receive context.
logging_state_t * | v22bis_get_logging_state (v22bis_state_t *s)
| Get the logging context associated with a V.22bis modem context.
int | v22bis_restart (v22bis_state_t *s, int bit_rate)
| Reinitialise an existing V.22bis modem context.
int | v22bis_request_retrain (v22bis_state_t *s, int bit_rate)
| Request a retrain for a V.22bis modem context.
int | v22bis_remote_loopback (v22bis_state_t *s, int enable)
| Request a loopback 2 for a V.22bis modem context.
int | v22bis_get_current_bit_rate (v22bis_state_t *s)
| Report the current operating bit rate of a V.22bis modem context.
v22bis_state_t * | v22bis_init (v22bis_state_t *s, int bit_rate, int guard, int calling_party, get_bit_func_t get_bit, void *get_bit_user_data, put_bit_func_t put_bit, void *put_bit_user_data)
| Initialise a V.22bis modem context.
int | v22bis_release (v22bis_state_t *s)
| Release a V.22bis modem receive context.
int | v22bis_free (v22bis_state_t *s)
| Free a V.22bis modem receive context.

## Variables

const complexf_t | v22bis_constellation [16]

## Macro Definition Documentation

## ms_to_symbols

#define ms_to_symbols | ( |  | t | ) |

Value:
(((t)*600)/1000)

## Function Documentation

## v22bis_free()

int v22bis_free | ( | v22bis_state_t * | s | ) |

Free a V.22bis modem receive context.

Free a V.22bis modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v22bis_get_current_bit_rate()

int v22bis_get_current_bit_rate | ( | v22bis_state_t * | s | ) |

Report the current operating bit rate of a V.22bis modem context.

Report the current operating bit rate of a V.22bis modem context.

Parameters

  s | The modem context.

## v22bis_get_logging_state()

logging_state_t * v22bis_get_logging_state | ( | v22bis_state_t * | s | ) |

Get the logging context associated with a V.22bis modem context.

Get the logging context associated with a V.22bis modem context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v22bis_state_s::logging.

## v22bis_init()

v22bis_state_t * v22bis_init | ( | v22bis_state_t * | s,
|  | int | bit_rate,
|  | int | guard,
|  | int | calling_party,
|  | get_bit_func_t | get_bit,
|  | void * | get_bit_user_data,
|  | put_bit_func_t | put_bit,
|  | void * | put_bit_user_data )

Initialise a V.22bis modem context.

Initialise a V.22bis modem context. This must be called before the first use of the context, to initialise its contents.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 1200 and 2400.
  guard | The guard tone option. 0 = none, 1 = 550Hz, 2 = 1800Hz.
  calling_party | TRUE if this is the calling modem.
  get_bit | The callback routine used to get the data to be transmitted.
  put_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer, passed in calls to the get and put routines.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References v22bis_state_s::bit_rate, v22bis_state_s::calling_party, v22bis_state_s::carrier_phase_rate, dds_phase_ratef(), v22bis_state_s::get_bit, v22bis_state_s::get_bit_user_data, v22bis_state_s::guard_phase_rate, v22bis_state_s::logging, v22bis_state_s::put_bit, v22bis_state_s::put_bit_user_data, v22bis_restart(), and v22bis_tx_power().

## v22bis_release()

int v22bis_release | ( | v22bis_state_t * | s | ) |

Release a V.22bis modem receive context.

Release a V.22bis modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v22bis_remote_loopback()

int v22bis_remote_loopback | ( | v22bis_state_t * | s,
|  | int | enable )

Request a loopback 2 for a V.22bis modem context.

Request a loopback 2 for a V.22bis modem context.

Parameters

  s | The modem context.
  enable | TRUE to enable loopback, or FALSE to disable it.

Returns
  0 for OK, -1 for request reject.

## v22bis_request_retrain()

int v22bis_request_retrain | ( | v22bis_state_t * | s,
|  | int | bit_rate )

Request a retrain for a V.22bis modem context.

Request a retrain for a V.22bis modem context. A rate change may also be requested.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 1200 and 2400.

Returns
  0 for OK, -1 for request rejected.

References v22bis_state_s::logging, SIG_STATUS_MODEM_RETRAIN_OCCURRED, span_log(), v22bis_state_s::training, and v22bis_state_s::training_count.

## v22bis_restart()

int v22bis_restart | ( | v22bis_state_t * | s,
|  | int | bit_rate )

Reinitialise an existing V.22bis modem context.

Reinitialise an existing V.22bis modem context, so it may be reused.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 1200 and 2400.

Returns
  0 for OK, -1 for bad parameter.

References v22bis_state_s::bit_rate.

Referenced by v22bis_init().

## v22bis_set_get_bit()

void v22bis_set_get_bit | ( | v22bis_state_t * | s,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Change the get_bit function associated with a V.22bis modem context.

Change the get_bit function associated with a V.22bis modem context.

Parameters

  s | The modem context.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

References v22bis_state_s::get_bit, and v22bis_state_s::get_bit_user_data.

## v22bis_set_modem_status_handler()

void v22bis_set_modem_status_handler | ( | v22bis_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.22bis modem receive context.

Change the modem status report function associated with a V.22bis modem receive context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v22bis_state_s::status_handler, and v22bis_state_s::status_user_data.

## v22bis_set_put_bit()

void v22bis_set_put_bit | ( | v22bis_state_t * | s,
|  | put_bit_func_t | put_bit,
|  | void * | user_data )

Change the put_bit function associated with a V.22bis modem context.

Change the get_bit function associated with a V.22bis modem context.

Parameters

  s | The modem context.
  put_bit | The callback routine used to process the data received.
  user_data | An opaque pointer.

References v22bis_state_s::put_bit, and v22bis_state_s::put_bit_user_data.

## v22bis_tx_power()

void v22bis_tx_power | ( | v22bis_state_t * | s,
|  | float | power )

Adjust a V.22bis modem transmit context's output power.

Adjust a V.22bis modem transmit context's power output.

Parameters

  s | The modem context.
  power | The power level, in dBm0

References dds_phase_ratef(), v22bis_state_s::gain, v22bis_state_s::guard_level, and v22bis_state_s::guard_phase_rate.

Referenced by v22bis_init().

## Variable Documentation

## v22bis_constellation

const complexf_t v22bis_constellation[16]

Initial value:
=
{
{ 1.0f, 1.0f},
{ 3.0f, 1.0f},
{ 1.0f, 3.0f},
{ 3.0f, 3.0f},
{-1.0f, 1.0f},
{-1.0f, 3.0f},
{-3.0f, 1.0f},
{-3.0f, 3.0f},
{-1.0f, -1.0f},
{-3.0f, -1.0f},
{-1.0f, -3.0f},
{-3.0f, -3.0f},
{ 1.0f, -1.0f},
{ 1.0f, -3.0f},
{ 3.0f, -1.0f},
{ 3.0f, -3.0f}
}